%global dlrn_nvr ovsdbapp-0.17.4-1.20220926213639.c5b598d
%global dlrn 1
%define upstream_version 0.17.4
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif
%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%global library ovsdbapp
%global module ovsdbapp
%global with_doc 0

%global common_desc \
A library for writing Open vSwitch OVSDB-based applications.

%global common_desc_tests \
Python OVSDB Application Library tests. \
This package contains Python OVSDB Application Library test files.

Name:       python-%{library}
Version: 0.17.4
Release: 1.20220926213640%{?dist}
Summary:    Python OVSDB Application Library
License:    ASL 2.0
URL:        http://launchpad.net/%{library}/

Source0: ovsdbapp-0.17.4-1.20220926213639.c5b598d.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=c5b598dd8d4415b014750384325589cb3fe3541c
Patch0001: 0001-Add-QoSDelExtIdCommand.patch
Patch0002: 0002-Add-lock-when-calling-idl.run.patch
Patch0003: 0003-Don-t-give-up-when-an-Exception-happens-in-idl.run.patch
Patch0004: 0004-Avoid-race-condition-with-RowEvent-handling.patch
Patch0005: 0005-Add-indexed-column-support-to-ovsdbapp.patch
Patch0006: 0006-Handle-index-lookups-in-DbFindCommand.patch
Patch0007: 0007-Add-an-active-wait-in-the-Backend.lookup.patch
Patch0008: 0008-Set-the-default-lookup-timeout-to-2-seconds.patch
Patch0009: 0009-Revert-Set-the-default-lookup-timeout-to-2-seconds.patch
Patch0010: 0010-Update-QoS-register-in-QoSAddCommand-if-exists.patch
Patch0011: 0011-Log-what-exception-caused-abort-of-the-transaction.patch
Patch0012: 0012-github-no-longer-accepts-git-connections.patch
Patch0013: 0013-More-robustly-handle-venv-ovs-ovn-paths.patch
Patch0014: 0014-Add-cooperative_yield-to-OvsdbIdl.patch
Patch0015: 0015-Add-if_exists-parameter-to-QoSDelCommand.patch
Patch0016: 0016-Fix-TRY_AGAIN-handling.patch
Patch0017: 0017-Don-t-force_reconnect-on-unhandled-Idl-exception.patch

BuildArch:  noarch

BuildRequires:  git
BuildRequires:  openstack-macros

%package -n python%{pyver}-%{library}
Summary:    Python OVSDB Application Library
%{?python_provide:%python_provide python%{pyver}-%{library}}
Requires:   python%{pyver}-openvswitch
Requires:   python%{pyver}-pbr
Requires:   python%{pyver}-six
Requires:   python%{pyver}-netaddr >= 0.7.18

BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-pbr
BuildRequires:  python%{pyver}-setuptools
BuildRequires:  python%{pyver}-mock
BuildRequires:  python%{pyver}-openvswitch
BuildRequires:  python%{pyver}-oslotest
BuildRequires:  python%{pyver}-stestr
BuildRequires:  python%{pyver}-netaddr >= 0.7.18
BuildRequires:  python%{pyver}-testrepository

%description -n python%{pyver}-%{library}
%{common_desc}


%package -n python%{pyver}-%{library}-tests
Summary:   Python OVSDB Application Library Tests
Requires:  python%{pyver}-%{library} = %{version}-%{release}
Requires:  python%{pyver}-fixtures
Requires:  python%{pyver}-mock
Requires:  python%{pyver}-oslotest
Requires:  python%{pyver}-testrepository

%description -n python%{pyver}-%{library}-tests
%{common_desc_tests}

%if 0%{?with_doc}
%package -n python-%{library}-doc
Summary:    Python OVSDB Application Library documentation

BuildRequires: python%{pyver}-sphinx
BuildRequires: python%{pyver}-openstackdocstheme

%description -n python-%{library}-doc
%{common_desc}

This package contains the documentation.
%endif

%description
%{common_desc}


%prep
%autosetup -n %{library}-%{upstream_version} -S git

# Let's handle dependencies ourselves
%py_req_cleanup

%build
%{pyver_build}

%if 0%{?with_doc}
# generate html docs
%{pyver_bin} setup.py build_sphinx
# remove the sphinx-build-%{pyver} leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%install
%{pyver_install}

%check
PYTHON=%{pyver_bin} OS_TEST_PATH=./ovsdbapp/tests/unit stestr-%{pyver} run

%files -n python%{pyver}-%{library}
%doc README.rst
%license LICENSE
%{pyver_sitelib}/%{module}
%{pyver_sitelib}/%{module}-*.egg-info
%exclude %{pyver_sitelib}/%{module}/tests

%files -n python%{pyver}-%{library}-tests
%{pyver_sitelib}/%{module}/tests

%if 0%{?with_doc}
%files -n python-%{library}-doc
%doc doc/build/html
%license LICENSE
%endif

%changelog
* Wed Nov 23 2022 Thierry Vignaud <tvignaud@redhat.com> 0.17.4-1.20220926213640
- Don't force_reconnect() on unhandled Idl exception (rhbz#2137698)

* Mon Sep 26 2022 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20220926213639.c5b598d
- Fix TRY_AGAIN handling (rhbz#2128914)

* Mon Jul 11 2022 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20220711153750.c5b598d
- Add "if_exists" parameter to "QoSDelCommand" (rhbz#2010672)

* Wed Jul 06 2022 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20220706193431.c5b598d
- Add cooperative_yield() to OvsdbIdl (rhbz#2085576)
- More robustly handle venv ovs/ovn paths

* Wed Jul 06 2022 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20220706183753.c5b598d
- github no longer accepts git:// connections

* Wed Mar 02 2022 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20220302223806.c5b598d
- Log what exception caused abort of the transaction (rhbz#2031728)

* Wed Feb 09 2022 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20220209174444.c5b598d
- Update QoS register in "QoSAddCommand" if exists (rhbz#2010672)

* Thu Aug 05 2021 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20210805133306.c5b598d
- Revert "Set the default "lookup" timeout to 2 seconds"

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20210528045446.c5b598d
- Update patches

* Mon May 10 2021 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20210510073307.c5b598d
- Update patches

* Mon May 10 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 0.17.4-1.20210505093301
- Set the default "lookup" timeout to 2 seconds (rhbz#1955545)

* Wed May 05 2021 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1.20210505093300.c5b598d
- Add an active wait in the "Backend.lookup" (rhbz#1955545)

* Wed Mar 10 2021 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1
- Update patches

* Wed Dec 09 2020 Terry Wilson <twilson@redhat.com> 0.17.4-1.20201114022230
- Handle index lookups in DbFindCommand

* Tue Nov 24 2020 Terry Wilson <twilson@redhat.com> 0.17.4-1.20201114022229
- Add indexed column support to ovsdbapp (rhbz#1895802)
- Avoid race condition with RowEvent handling
- Don't give up when an Exception happens in idl.run
- Add lock when calling idl.run()

* Fri Nov 13 2020 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1
- Update patches

* Thu Oct 08 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 0.17.4-1.20200828083360
- Add QoSDelExtIdCommand (rhbz#1859274)

* Fri Aug 28 2020 OSP Prod Chain <dev-null@redhat.com> 0.17.4-1
- Update patches
- OVNNB backend: Fix LbDelCommand when using vip param
- Fix pep8 job

* Thu May 28 2020 OSP Prod Chain <dev-null@redhat.com> 0.17.3-1
- Update patches

* Thu May 28 2020 OSP Prod Chain <dev-null@redhat.com> 0.17.2-1
- Update patches
- Add "inactivity_probe" parameter to "enable_connection_uri"
- Fix spurious test failure
- Allow read-only Commands to bypass txns in execute()
- Accept a Row as a result in AddCommand
- Call row.verify() when updating map columns with db_set

* Tue Mar 10 2020 OSP Prod Chain <dev-null@redhat.com> 0.17.2-1
- Update patches

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 0.17.2-1
- Update patches

* Wed Feb 19 2020 OSP Prod Chain <dev-null@redhat.com> 0.17.2-1
- Update patches
- Log invalid address values in lsp_set_addresses

* Mon Dec 16 2019 OSP Prod Chain <dev-null@redhat.com> 0.17.1-1
- Update patches
- Handle unset OVN_SRCDIR
- Update TOX/UPPER_CONSTRAINTS_FILE for stable/train
- Fix all of the train gate issues

* Mon Sep 23 2019 OSP Prod Chain <dev-null@redhat.com> 0.17.0-1
- Update patches

* Fri Sep 20 2019 RDO <dev@lists.rdoproject.org> 0.17.0-1
- Update to 0.17.0


